use diesel::{Connection, SqliteConnection};

pub enum DbConn {
    // Currently only sqlite Connection
    SqliteConn(SqliteConnection),
}

impl DbConn {
    pub fn establish_sqlite(database_url: &str) -> anyhow::Result<Self> {
        Ok(Self::SqliteConn(SqliteConnection::establish(database_url)?))
    }
}

#[cfg(test)]
mod tests {
    use super::DbConn;

    #[test]
    fn test_establish_sqlite() {
        let workspace = env!("CARGO_MANIFEST_DIR");
        let db_url = format!("{}/ygopro-database/locales/zh-CN/cards.db", workspace);
        let _conn = DbConn::establish_sqlite(&db_url).unwrap();
    }
}
